'==========================================================================================
' Create_Handbrake_Queue.vbs
' VBScript for Total Commander (TC) button-bar
' 
' Input parameters:
' %L PathToHandBrakePresetFile Postfix(optional)

' %L - TC key for generating list with full path to the video-files	
'PathToHandBrakePresetFile contains template for Handbrake QueueTask:
' <QueueTask>			
'...
'</QueueTask>
'
'Postfix
'Postfix for the created new video file 
'default: _new'

' Output:
' Script creates MyHBqueue.hbq file in current working directory
' One can import this file  in Queue HandBrake
'
' Author: priester
' 08.07.2016 - v1.0
' 

'==========================================================================================
Option Explicit

' Code constants===========================================================================
Dim NewQueueFile
NewQueueFile="MyHBqueue.hbq"
Dim InputFile_str
InputFile_str="INPUTFILENAME"
Dim OutputFile_str
OutputFile_str="OUTPUTFILENAME"

Dim Queue_open_str
Queue_open_str="<?xml version=""1.0""?>" & vbCrLf & _
"<ArrayOfQueueTask xmlns:xsd=""http://www.w3.org/2001/XMLSchema"" xmlns:xsi=""http://www.w3.org/2001/XMLSchema-instance"">" & vbCrLf

Dim Queue_close_str
Queue_close_str="</ArrayOfQueueTask>"

'Input parameters===========================================================================
DIM FileList
FileList   =WScript.Arguments(0)
DIM PresetsFile
PresetsFile=WScript.Arguments(1)
DIM Postfix
Postfix="_new"
Dim objArgs, I
Set objArgs = WScript.Arguments
If CInt(objArgs.Count)=3 then
' Postfix is posfix parameter is passed as 3rd string to script
Postfix=WScript.Arguments(2)
End If

'Read contents of PresetsFile to variable strDataPresets====================================
Dim InputFile
Dim objFSO1, objFile1
Dim strDataPresets
InputFile = PresetsFile
Set objFSO1 = CreateObject("Scripting.FileSystemObject")
Set objFile1 = objFSO1.OpenTextFile(InputFile)
strDataPresets = objFile1.ReadAll
objFile1.Close


'Create New Queue file======================================================================= 
Dim outFile
outFile=NewQueueFile
'Set objFile1 = objFSO1.CreateTextFile(outFile,True)

'objFile1.Write Queue_open_str

' Start filling queue-file with data: cycle through all files in %L-list=====================
Dim FSO, OTF
Set FSO = CreateObject("Scripting.FileSystemObject")
Set OTF = FSO.OpenTextFile(FileList, 1)

' Use Microsoft ActiveX Data Objects (ADO) for UTF-8
'http://developer.rhino3d.com/guides/rhinoscript/read_write_utf8/
Dim objStream
Set objStream = CreateObject("ADODB.Stream")
objStream.CharSet = "utf-8"
objStream.Open
objStream.WriteText Queue_open_str
'objStream.SaveToFile "C:\Users\admin\Desktop\test.txt", 2

Do While Not OTF.AtEndOfStream

	DIM currFileName
	currFileName = OTF.ReadLine

	  If InStr(1, currFileName, " ", 1) > 0 Then
		currFileName = chr(34) & currFileName & chr(34)
	  End If

	currFileName=replace(currFileName, chr(34), "")

	DIM objFSO, objFile
	Set objFSO  = CreateObject("Scripting.FileSystemObject")
	Set objFile = objFSO.GetFile(currFileName)

	'Path and Filename parameters of the current file
	DIM AbsPath, FileName, FileNameNoExt, FileExt, ParentFolder
	AbsPath      =objFSO.GetAbsolutePathName(objFile)
	ParentFolder =objFSO.GetParentFolderName(objFile)
	FileName     =objFSO.GetFileName        (objFile)
	FileNameNoExt=objFSO.GetBaseName        (objFile)
	FileExt      =objFSO.GetExtensionName   (objFile)

	' Form <QueueTask> section from preset
	DIM queue_str
	DIM objRegEx
	Set objRegEx = CreateObject("VBScript.RegExp")
	objRegEx.Global     = True
	objRegEx.IgnoreCase = False
	objRegEx.Pattern    = InputFile_str
	Dim InputFileName
	InputFileName= ParentFolder & "\" & FileNameNoExt & "." & FileExt
	queue_str        = objRegEx.Replace(strDataPresets,InputFileName)
	Dim NewFileName
	NewFileName= ParentFolder & "\" & FileNameNoExt & Postfix & "." & FileExt
	objRegEx.Pattern = OutputFile_str
	queue_str         = objRegEx.Replace(queue_str,NewFileName)

	objStream.WriteText queue_str
	objStream.WriteText vbCr & vbLf
	'objFile1.Write queue_str
	'objFile1.Write vbCr & vbLf
Loop ' cycle through all files in list (created with Total Commander %L key)


'objFile1.Write Queue_close_str
objStream.WriteText Queue_close_str
objStream.SaveToFile outFile, 2

OTF.Close
Set OTF     = Nothing
Set FSO     = Nothing
Set objFile = Nothing

WScript.Echo "--End without errors--"
WScript.Quit
